CREATE OR REPLACE TABLE country (country_id CHAR(2) PRIMARY KEY, country_name VARCHAR(100) NOT NULL);

CREATE OR REPLACE TABLE state_province (state_code CHAR(2) PRIMARY KEY, 
NAME VARCHAR(50) NOT NULL);

CREATE OR REPLACE TABLE weather_station(station_id CHAR(12) PRIMARY KEY,
latitude float NOT NULL,
longitude float NOT NULL,
elevation FLOAT NOT NULL,
station_state CHAR(2) FOREIGN KEY REFERENCES state_province (state_code) NULL,
station_name VARCHAR (40) NOT NULL,
gsn CHAR(5) NULL,
hcn_crn CHAR(5) NULL,
wmo_id CHAR(5) NULL);


CREATE OR REPLACE TABLE station_data_inventory (entry_id INT IDENTITY PRIMARY KEY,
station_id CHAR(12) FOREIGN KEY REFERENCES weather_station (station_id),
latitude float NOT NULL,
longitude float NOT NULL,
element VARCHAR(4) NOT NULL,
first_year INT,
last_year INT);

CREATE OR REPLACE TABLE station_data (
    entry_id INT IDENTITY PRIMARY KEY,
    station_id CHAR(12) FOREIGN KEY REFERENCES weather_station (station_id),
    data_date DATE NOT NULL,
    element CHAR(4) NOT NULL,
    element_value INT NOT NULL,
    mflag CHAR(1),
    qflag CHAR(1),
    sflag CHAR(1),
    obs_time TIME
);

CREATE OR REPLACE FILE FORMAT comma_csv_format
                                          type = 'CSV'
                                          field_delimiter = ',';

COPY INTO STATION_DATA 
(STATION_ID, DATA_DATE, ELEMENT, ELEMENT_VALUE, MFLAG, QFLAG, SFLAG, OBS_TIME)
FROM
(select 
t.$1, TO_DATE(t.$2, 'yyyymmdd'), t.$3, t.$4, t.$5, t.$6, t.$7, TO_TIME(t.$8, 'hhmm') 
from @my_csv_stage 
(file_format => 'COMMA_CSV_FORMAT', pattern => '.*superghcnd_.*.csv.gz') t);